CLS
start = TIMER
LOCATE 5, 1
PRINT "Program to replace spaces with underscores in DXF layer names"
PRINT
PRINT "Enter drive, directory, and filename for both input and output files"
PRINT
PRINT "  e.g. D:\IMPORT\GEOLOGY\ELBOW\ELBGEO.DXF"
PRINT
PRINT

'Prompt for input and output files and check whether they exist or not.
'If input file does not exist, then end
'If output already exists, prompt for permission to overwrite

INPUT "INPUT DXF  : ", InFile$
InFile$ = UCASE$(InFile$)
FileToCheck$ = InFile$
GOSUB CheckFile
IF YorN$ = "N" THEN
  PRINT "Input file does not exist"
  END
END IF
INPUT "OUTPUT DXF : ", OutFile$
OutFile$ = UCASE$(OutFile$)
FileToCheck$ = OutFile$
GOSUB CheckFile
IF YorN$ = "Y" THEN
  PRINT "Output file already exists ... overwrite (Y,N) ?"
  a$ = INPUT$(1): a$ = UCASE$(a$)
  IF a$ = "N" THEN END
END IF
PRINT

'Open input and output files and begin cleaning of DXF files.

OPEN InFile$ FOR INPUT AS #1
OPEN OutFile$ FOR OUTPUT AS #2
FileSize = LOF(1)
LOCATE 15, 5: PRINT "% complete"
WHILE EOF(1) <> -1
  LINE INPUT #1, a$
  IF INSTR(a$, " - ") THEN
    GOSUB OneDash
  ELSEIF INSTR(a$, " ") > 1 THEN
    GOSUB OneSpace
  END IF
  PRINT #2, a$
WEND

LOCATE 15, 1
PRINT "Time to process file : "; (TIMER - start) / 60; " minutes"
CLOSE
END

OneDash:
'Replace DXF layer names containing " - " with "_"
SpaceLoc% = INSTR(a$, " - ")
a$ = MID$(a$, 1, SpaceLoc% - 1) + "_" + MID$(a$, SpaceLoc% + 3, LEN(a$))
LOCATE 15, 1: PRINT INT((LOC(1) * 128 / FileSize) * 100)
RETURN

OneSpace:
'Replace DXF layer names containing " " with "_"
SpaceLoc% = INSTR(a$, " ")
a$ = MID$(a$, 1, SpaceLoc% - 1) + "_" + MID$(a$, SpaceLoc% + 1, LEN(a$))
LOCATE 15, 1: PRINT INT((LOC(1) * 128 / FileSize) * 100)
RETURN

CheckFile:
'Check if file exists
OPEN FileToCheck$ FOR RANDOM AS #1
IF LOF(1) = 0 THEN
  YorN$ = "N"
  CLOSE #1
  KILL FileToCheck$
ELSE
  YorN$ = "Y"
  CLOSE #1
END IF
RETURN

